unit SoundStreaming;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, openal, OpenALStreamingObjectU, ExtCtrls, ComCtrls;
type
  TForm4 = class(TForm)
    Button1: TButton;
    Timer1: TTimer;
    tbVolume: TTrackBar;
    tbFrequency: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure tbVolumeChange(Sender: TObject);
    procedure tbFrequencyChange(Sender: TObject);
  private
    { Private declarations }
    fOpenALStreamingObject: TOpenALStreamingObject;
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

procedure TForm4.Button1Click(Sender: TObject);
begin
  if (Sender as TButton).Caption = 'Play' then
  begin
    fOpenALStreamingObject.Play;
    (Sender as TButton).Caption := 'Stop';
  end else begin
    fOpenALStreamingObject.Stop;
    if (fOpenALStreamingObject.IsPlaying = False) then
    begin
      (Sender as TButton).Caption := 'Play';
    end;
  end;
end;

procedure TForm4.FormCreate(Sender: TObject);
var
  argv: array of PalByte;
begin
  // Initialise the OpenAL library.
  InitOpenAL;
  alutInit(nil, argv);
  fOpenALStreamingObject := TOpenALStreamingObject.Create;
end;

procedure TForm4.FormDestroy(Sender: TObject);
begin
  fOpenALStreamingObject.Free;
  // Close OpenAL
  alutExit;
end;

procedure TForm4.tbFrequencyChange(Sender: TObject);
begin
  fOpenALStreamingObject.Frequency := tbFrequency.Position;
end;

procedure TForm4.tbVolumeChange(Sender: TObject);
begin
  // Send the new volume to our streaming object;
  fOpenALStreamingObject.Volume := tbVolume.Position;
end;

end.
